Index: src/backend/commands/copy.c
===================================================================
RCS file: /projects/cvsroot/pgsql/src/backend/commands/copy.c,v
retrieving revision 1.245
diff -c -r1.245 copy.c
*** src/backend/commands/copy.c	2 Jun 2005 01:21:22 -0000	1.245
--- src/backend/commands/copy.c	27 Jun 2005 18:45:39 -0000
***************
*** 2732,2738 ****
  
  		if (!same_encoding)
  		{
! 			/* send additional bytes of the char, if any */
  			mblen = pg_encoding_mblen(client_encoding, string);
  			for (i = 1; i < mblen; i++)
  				CopySendChar(string[i]);
--- 4379,4387 ----
  
  		if (!same_encoding)
  		{
! 			/*
! 			 * send additional bytes of the char, if any
! 			 */
  			mblen = pg_encoding_mblen(client_encoding, string);
  			for (i = 1; i < mblen; i++)
  				CopySendChar(string[i]);
***************
*** 2759,2765 ****
  
  	if (attnamelist == NIL)
  	{
! 		/* Generate default column list */
  		TupleDesc	tupDesc = RelationGetDescr(rel);
  		Form_pg_attribute *attr = tupDesc->attrs;
  		int			attr_count = tupDesc->natts;
--- 4408,4416 ----
  
  	if (attnamelist == NIL)
  	{
! 		/*
! 		 * Generate default column list
! 		 */
  		TupleDesc	tupDesc = RelationGetDescr(rel);
  		Form_pg_attribute *attr = tupDesc->attrs;
  		int			attr_count = tupDesc->natts;
***************
*** 2774,2780 ****
  	}
  	else
  	{
! 		/* Validate the user-supplied list and extract attnums */
  		ListCell   *l;
  
  		foreach(l, attnamelist)
--- 4425,4433 ----
  	}
  	else
  	{
! 		/*
! 		 * Validate the user-supplied list and extract attnums
! 		 */
  		ListCell   *l;
  
  		foreach(l, attnamelist)
***************
*** 2782,2791 ****
  			char	   *name = strVal(lfirst(l));
  			int			attnum;
  
! 			/* Lookup column name, ereport on failure */
! 			/* Note we disallow system columns here */
  			attnum = attnameAttNum(rel, name, false);
! 			/* Check for duplicates */
  			if (list_member_int(attnums, attnum))
  				ereport(ERROR,
  						(errcode(ERRCODE_DUPLICATE_COLUMN),
--- 4435,4450 ----
  			char	   *name = strVal(lfirst(l));
  			int			attnum;
  
! 			/*
! 			 * Lookup column name, ereport on failure
! 			 */
! 			/*
! 			 * Note we disallow system columns here
! 			 */
  			attnum = attnameAttNum(rel, name, false);
! 			/*
! 			 * Check for duplicates
! 			 */
  			if (list_member_int(attnums, attnum))
  				ereport(ERROR,
  						(errcode(ERRCODE_DUPLICATE_COLUMN),
***************
*** 2797,2799 ****
--- 4456,4524 ----
  
  	return attnums;
  }
+ 
+ /******************************************************
+  * utility functions, should be placed elsewhere in src
+  ******************************************************/
+ 
+ /*
+  * These are custom versions of the string function strchr().
+  * As opposed to the original strchr which searches through
+  * a string until the target character is found, or a NULL is
+  * found, this version will not return when a NULL is found.
+  * Instead it will search through a pre-defined length of
+  * bytes and will return only if the target character(s) is reached.
+  *
+  * If our client encoding is not a supported server encoding, we
+  * know that it is not safe to look at each character as trailing
+  * byte in a multibyte character may be a 7-bit ASCII equivalent.
+  * Therefore we use pg_encoding_mblen to skip to the end of the
+  * character.
+  *
+  * parameters:
+  *	 s	  - string being searched.
+  *	 c(n) - char we are searching for.
+  *	 len  - maximum # of bytes to search.
+  *
+  * returns:
+  *	 pointer to c - if c is located within the string.
+  *	 NULL - if c was not found in specified length of search. Note:
+  *			this DOESN'T mean that a '\0' was reached.
+  */
+ char *
+ strchrlen(const char *s, int c, size_t len)
+ {
+ 	const char *start;
+ 
+ 	if (client_encoding_only)
+ 	{
+ 		int			mblen = pg_encoding_mblen(client_encoding, s);
+ 
+ 		for (start = s; *s != c && s < start + len; s += mblen)
+ 			mblen = pg_encoding_mblen(client_encoding, s);
+ 	}
+ 	else
+ 		/*
+ 		 * safe to scroll byte by byte
+ 		 */
+ 	{
+ 		for (start = s; *s != c && s < start + len; s++)
+ 			;
+ 	}
+ 
+ 	return ((*s == c) ? (char *) s : NULL);
+ }
+ 
+ char *
+ str2chrlen(const char *s, int c1, int c2, size_t len, char *c_found)
+ {
+ 	const char *start;
+ 
+ 	*c_found = '\0';
+ 
+ 	for (start = s; *s != c1 && *s != c2 && s < start + len; s++)
+ 		;
+ 
+ 	*c_found = *s;
+ 	return (*c_found != '\0' ? (char *) s : NULL);
+ }
